#include <bits/stdc++.h>
using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, k, x, t, q;
    cin>>n>>k>>x;

    q = (n-x)*(n-x+1)/2;
    if(k < q)
    {
        cout<<-1;
    }
    else
    {
        t = (n*(n-1))/2 - k;
        for(int i = n-1; i >= 0; i --)
        {
            cout<<i*x+1-t<<" ";
            if(t>0)
                t--;
        }
    }
    return 0;
}